
(Synthèse de différentes notions sur la récursivité
 (Préambule : la nécessité de s'adapter
  (Il faut savoir s'adapter : en fonction du problème à traiter, on choisit la structure du langage de programmation. Voici différents problèmes et le langage choisi pour mieux les traiter :
   (SMA Système multi agents : Un problème où existent beaucoup d'entités. Ex : la circulation automobile en ville, des bateaux dans un port⊉ → langage objets.)
   (Un problème où existe beaucoup de données → SGBD ⊈Système de Gestion de Bases de Données⊉.)
   (Un programme qui doit tourner vite : C, assembleur.)
   (Un problème d'analyse syntaxique ⊈du LN mais surtout d'un programme informatique⊉ : un langage traitant la récursivité ⊈lisp, prolog, java, pascal, C⊉.) ) 
  (La récursivité existe dans la nature, pour nous en convaincre, regardons quelques exemples : §/fractal/chou.JPG
   (Le chou fleur, les tiges des fleurs : §/fractal/arb/parasol.png)
   (La ramure des arbres : §/fractal/arb/24bit-6.png)
   (Les paysages, qui sont fractals : §/fractal/ex/Logo3D.png) ) 
  (Tout ça c'est pour dire que, la récursivité, on ne peut pas y échapper !
   (Et puis, ça ne va pas être si terrible que ça, car nous avons déja bien dégrossi le problème.) ) ) 
 (Introduction, au moyen de l'histoire du nain et de la fée.
  (Un nain rend service à une fée. Pour le remercier elle lui accorde deux vœux. D'abord, il demande un habit brodé d'or... )
  (Puis, comme second vœu : un crédit de deux vœux. En procédant ainsi systématiquement ⊈récursivement⊉, il peut tout obtenir de la fée. ) ) 
 (Indice marqueur de la récursivité : la notion de définition circulaire
  (Une définition est dite circulaire, quand, pour définir un terme, elle utilise ce même terme
   (Remarque : ce n'est pas très futé) ) 
  (Mais cette mésaventure peut même arriver à des gens bien.
   (Ex : en 1956, Mc Carthy, au Dartmouth college, définit ainsi l'intelligence artificielle ⊈I.A.⊉ : §/lisp/McCarthy.png
    (C'est effectuer un traitement qui serait considéré comme intelligent s'il était effectué par un humain.) ) 
   (Cette définition est circulaire car pour définir l'intelligence artificielle elle évoque l'intelligence des humains.)
   (L'intérêt pour le locuteur d'utiliser cette définition est qu'elle lui évite de définir la notion d'intelligence.)
   (Dans l'histoire des sciences, les philosophes ne se sont pas gênés pour la railler. ) ) ) 
 (Notation de la récursivité
  (Exemple classique des mathématiques :
   (La définition de factorielle : §/récur/BNF.png
    (fact n ::= n * fact ⊈n-1⊉ ; la partie récursive de la définition.)
    (fact 1 ::= 1 ; les deux conditions d'arrêt.)
    (fact 0 ::= 0.) ) 
   (Les notations qui utilisent la chaîne "::=" pour signifier une sorte d'équivalence se nomment : formes de Backus Naur.
    (Ces deux personnes ne sont rien de moins que les créateurs de Fortan, le premier des langages macroscopiques.) ) 
   (Même si ce langage n'est qu'un L3G ⊈langage de la 3ème génération⊉ ils ont leur place dans ce cours, car, à son propos, ils ont écrit cette réflexion très intéressante :
    (Tous ces mois passés à écrire le code de ce compilateur constituèrent pour nous une période de forte excitation intellectuelle. )
    (En effet, parfois nous étions surpris par les optimisations judicieuses qu'il effectuait, car nous n'y avions jamais pensé !) ) ) 
  (Exemple plus simple de l'analyse d'un groupe nominal récursif :
   (Comptine à analyser : la puce du bout du poil, du bout de la queue du chien de la fille de Mme Gaspard.)
   (On remplace 'du' par son équivalent : 'de le'.)
   (On utilise la grammaire suivante :
    (GN ::= DET NOM de la GN)
    (GN ::= DET NOM de le GN)
    (GN ::= DET NomPropre) ) 
   (Et on obtient ceci : §/récur/gaspard.png) ) 
  (Note : comment remarquer l'empreinte de la récursivité dans une définition formelle ?
   (La marque de la récursité c'est quand le terme de gauche est défini en fonction de lui-même ⊈avec un affaiblissement tout de même⊉. §/grammar/syntaxeD1insJFL_C.png)
   (Dans ce cas il est forcément dans la partie de gauche. Et on le voit apparaître immédiatement à droite de la définition ⊈ou dans les sous-définitions suivantes⊉. ) ) ) 
 (Application : présenter le monde '∫ky2+rtr', un domaine riche et dense grâce sa double aptitude à la COMPOSITION RÉCURSIVE
  (Rapide positionnement de son mode opératoire, par opposition à ∫ky3+AF très simple mais limité
   (Car avec AF-∫ky3 l'action conditionnelle constituait seulement en un changement d'état du monde. §/AFini/graph/feuEtFuit.png
    (Voici l'exemple important d'un jeu de rôle, créé par les animateurs de PLJ où les enfants se prennent au jeu. )
    (Pourtant toute cette organisation est seulement accrochée à l'état du monde, réduit au n° de la page HTML correspondante.)
    (Le maximum qu'on puisse faire avec AF-∫ky3 c'est représenter l'état du monde par un tableau fini ⊈ex. l'état du jeu de plateau⊉ car cet état demeure de taille finie.) ) ) 
  (Convention pédagogique : convenons de noter que la récursivité de ∫ky2+rtr permet une composition²
   (En effet, l'amélioration apportée par la compositionnalité² se fait dans 2 directions : composition 1⊉des procès effectués, 2⊉des structures générées)
   (1⊉ ∫ky2+rtr introduit la composition des traitements effectués sur les données ⊈*a⊉ ou sur le monde ⊈*b⊉
    (*a⊉ Puisque ∫ky2+rtr COMPOSE les traitements des données il possède ainsi la puissance de traitement d'un calculateur.
     (Aspect compositionnel : un procès est défini comme la composition de N sous-procès.
      (De façon abstraite, mathématique : la donnée ayant subi le procès1 est ensuite modifiée par le procès2. §/compose/f°/gof.png)
      (De façon concrète, physique : l'état du monde ⊈plateau⊉ ayant subi le procès1 est ensuite modifiée par le procès2. §/compose/a.png) ) 
     (Note : tant qu'il n'est pas relié au monde, le calculateur ne peut travailler que sur ses registres internes : il est sollipsiste.) ) 
    (*b⊉ Plonger un calculateur ⊈sollipsiste⊉ dans le monde le rend capable d'actions sur ce dernier : il devient un automate programmable industriel ⊈API⊉.
     (En effet, quand un calculateur ne traite plus des données, mais est plongé dans le monde et pilote plutôt des actions, il devient un API.)
     (Conclusion : quand il est enrichi d'actions sur le monde, ∫ky2+rtr possède la puissance de l'API, ce qui est considérable !) ) ) 
   (2⊉ ∫ky2+rtr introduit une construction RÉCURSIVE, COMPOSITIONNELLE des entités du monde et donc des données les représentant
    (Par assemblage à l'ordre N de composants ⊈càd de sous-parties⊉ il peut construire des entités complexes du monde :
     (Une maison est composée de N salles. §/mond-ηDu/big1/5.png)
     (Chaque salle reçoit son mobilier, où, de même, chaque meuble ⊈chaise table⊉ apparaît comme un assemblage de pieds et de plans. §/chaise/assembler.png) ) 
    (Regardons quelques autres exemples variés
     (- Construction en couches d'un système d'exploitation : depuis le noyau central, toutes les instructions sont construites strate après strate, §/structLayers/layerOrganisa°.png)
     (- Construction causale d'un raisonnement : à partir des faits de base, on en déduit de nouveaux qui enrichissent progressivement notre savoir §/structOignon/ttLeProcès.png)
     (- En haut à gauche, l'évaluation récursive de fact⊈3⊉ rend 6. 
      (Tout le code est progressivement accroché à l'expression centrale. §/lisp/exec/nice1.png)
      (Attention : l'évaluation de 'fact⊈3⊉' présentée ici, expanse le dessin : au fil du procès elle alloue de la mémoire. Elle n'est plus ∫ky2 mais ∫ky1 !) ) ) 
    (Conclusion : au moyen de méthodes récursives, fractales, ∫ky2+rtr peut construire des entités plus épaisses, plus riches.
     (La diversité des entités ainsi produites est bien visualisée par la richesse des taxinomies des entités fabriquées. §/taxinomy/fmPhd-pratiq/20En3Parties.bmp) ) ) ) ) 
 (Applications : 3 exemples d'analyse syntaxique d'une chaîne, du plus simple au plus complexe : AFD, RTR, RTA
  (AFD : Automate à états finis
   (Analyser un groupe nominal
    (La règle s'écrit : GN ::= DET NOM ADJ.)
    (Note : DET=déterminant ; NOM=nom ; ADJ=adjectif ) ) 
   (Ex : analyser la chaîne : le chat noir
    (D'abord une généralisation où nous la traduisons au moyen d'un dictionnaire de types : le→DET ; chat→NOM ; noir→ADJ.)
    (Le graphe de l'AFD correspondant à cette règle est simple : ⊈1⊉ −DET→ ⊈2⊉ −NOM→ ⊈3⊉ −ADJ→ ⊈4⊉) ) ) 
  (RTR : un réseau de transition récursif §all/rtr/graf/a.png
   (Nous analysons des phrases avec relatives)
   (Exemple des relatives en anglais : §/rtr/Ana1phrRelatAngl/theManIsKind.png
    (Ici la structure est plus simple à dessiner, mais l'analyse est plus dure à effectuer car la syntaxe anglaise occulte le marqueur 'dont'.)
    (The house, the man, the hat is black, is kind, is large. §/rtr/Ana1phrRelatAngl/sansPil.png) ) 
   (Exemple des relatives en Français. §/rtr/Ana1phrRelatFranc/JeLookLaMaison.png
    (La structure est plus complexe à dessiner, mais l'analyse ⊈et la compréhension⊉ est plus simple à effectuer car les marqueurs ⊈dont qui⊉ balisent le traitement.)
    (Le chat regarde la cheminée qui fume, sous la lune. §/rtr/Ana1phrRelatFranc/LeCatLookLaChimneyQuiFume.png)
    (Je regarde la maison, dont le toît qui fume est cassé, sous la lune. §/rtr/Ana1phrRelatFranc/JeLookLaMaisonSousLaLune.png) ) ) 
  (R T A = A T N : Réseau de Transition Augmenté ⊈d'actions sur le monde⊉
   (Tout d'abord, précisons les abréviations utilisées dans ce paragraphe
    (En français
     (RTA : réseau de transition augmenté d'actions.)
     (TLN / TAL : traitement ⊈automatique⊉ du langage ⊈naturel⊉) ) 
    (En anglais
     (ATN : augmented transition Network)
     (NLP : natural language processing) ) ) 
   (Exemple classique d'un traitement effectué par un RTA :
    (Illustration 1 : le petit chat boit le bon lait devient : le bon lait est bu par le petit chat. §all/rta/transfoByRta.png
     (Le mécanisme peut être câblé comme un réseau de transition récursif enrichi d'un traitement par des registres : RTA ⊈∫ky2+⊉)
     (Si on programme ce traitement qui construit et rend un arbre, on doit utiliser un langage ∫ky1.) ) 
    (Transformer une phrase passive en phrase active ⊈ou réciproquement⊉
     (Voici la phrase initiale : la souris est mangée par le chat.) ) 
    (Après généralisation, on peut effectuer une analyse au moyen de la règle suivante : GN1 est PartPassé par GN2
     (Alors, à l'issue de l'analyse on obtient ce résultat, ce contexte :
      (GN1 → la souris)
      (PartPassé → mangée)
      (GN2 → le chat) ) 
     (Le réseau de transition est augmenté de traitements, c'est ainsi qu'on effectue :
      (Mangé⊈e⊉ → Participe passé du verbe dont l'infinitif est : manger.)
      (Présent du verbe 'manger' → mange.) ) 
     (À ce stade, nous obtenons l'environnement final.
      (GN1 → la souris)
      (verbPrésent → mange)
      (GN2 → le chat) ) 
     (Le canneva d'arrivée à atteindre est : GN2 verbPrésent GN1.
      (GN2 → le chat)
      (verbPrésent → mange)
      (GN1 → la souris) ) 
     (En substituant l'environnement dans le cannevas d'arrivée on obtient la phrase active résultat :
      (le chat mange la souris.) ) ) 
    (Deux autres exemples :
     (Remarque qui permet d'introduire la suite du cours : attention, ces traitements sont Chomsky 1 !)
     (Le chat noir boit le lait blanc. §/parse/c.png)
     (Le petit chat qui est beau, boit le bon lait. §/parse/tal.png) ) ) ) ) ) 