
(Généralités sur les Systèmes Experts ⊈SE⊉
 (Présentation basique d'un Système Expert :
  (Son synoptique consiste en 3 composantes : base de faits, base de règles, moteur d'inférence §/systExpert/coeur.png
   (Base de faits = {faits à propos du monde} = sa description statique : de son mobilier et de ses entités actives.)
   (Base de règles = {règles d'actions sur le monde} : sa représentation dynamique, càd les actions et les comportements des entités qui y sont actives.)
   (Moteur d'inférence : la machine qui fait le traitement : il applique les règles sur les faits décrivant le monde afin d'y simuler l'activité des agents situés.) ) 
  (Situer les SE Vs la programmation impérative ⊈PI⊉ : permettre une programmation déclarative ⊈P°D⊉ càd non-impérative pour coder l'activité d'un agent
   (Contrairement à la P°I qui déclenche et exécute une action, la P°D déclare des règles indépendantes d'activation, mais ne s'occupe pas de les déclencher.)
   (Donc la P°D introduit une simplification du codage : le programmeur décrit les règles mais c'est le moteur d'inférence qui est chargé de les appliquer.) ) 
  (Un exemple pratique pour illustrer la chose : SncfWst : les périgrinations d'un train sur le réseau ferré Ouest de la France.
   (Base de faits : la liste des villes où le train peut se trouver : { Paris Chartres Le_Mans Angers Nantes}. §/sncfWst/baseFait.png)
   (Base de règles : la liste des trajets possibles ''ville à ville''. §/sncfWst/regles.png)
   (Quand la commande ''⊈va 'Paris⊉'' lance le moteur d'inférence depuis le lieu de départ : 'Paris'. On obtient cette session = exécution : §/sncfWst/syntheGene.png) ) ) 
 (voir : La représentation des données et connaissances : modéliser un agent situé dans son monde pour y simuler son activité ⊈approche générale⊉.)
 (La programmation déclarative aide à implémenter ces représentations du monde de l'agent !
  (Rappel à propos des automates finis ⊈AF⊉ et la programmation : §/AFini/schema/prgmEtTabl.png
   (Remplir la table d'un AF équivaut à écrire un programme DÉCLARATIF §/AFini/table/parisNantes.png
    (L'AF est muni de l'alternative qui permet de réaliser des actions conditionnelles : arrivé au Mans, il faut choisir ! §/alternative/graphDeSymb.png)
    (Souvent, écrire un programme = composer des actions conditionnelles. §/AFini/ex/convers°/Base2a10.png)
    (Donc remplir la table d'un AF équivaut à écrire un programme : §/AFini/ex/convers°/tab.png)
    ( Il est constitué de clichés de transitions de l'état du monde : ⊈0,0⊉→0. ⊈0,1⊉→1. ⊈1,0⊉→2. ⊈1,1⊉→3. ⊈2,0⊉→4 ... Il rèleve de la programmation déclarative.) ) ) 
  (Sachant que : ''au moyen d'une règle de moteur 0, on peut décrire la transition codée par une case d'AF''.
   (Alors, plus généralement, au moyen de N règles d'un SE on peut écrire un programme DÉCLARATIF.) ) 
  (Le problème de la combinatoire dans la programmation déclarative :
   (Rappel du fonctionnement de la programmation déclarative :
    (Il faut que l'état du monde corresponde à la tête de règle. La queue de règle devient le nouvel état du monde. §/domino/partieY3Reg.png) ) 
   (Aspect positif : faire travailler l'ordinateur : on n'a pas à s'occuper du déclenchement de chaque règle, le moteur d'inférence se charge de ce travail.)
   (Aspect négatif : un programme déclaratif est plus long à exécuter/traiter qu'un programme classique ⊈impératif⊉ car...
    (Après avoir déclenché une règle, le moteur d'inférence doit chercher quelle sera la prochaine traitée, et cette recherche prend du temps. Ce non-déterminisme était le pb de Prolog.) ) ) ) 
 (Intérêt des moteurs 1 ⊈comparés aux moteurs 0⊉
  (Le problème de la combinatoire : comment le moteur 1 résoud cette difficulté qui apparaît dans dans le moteur 0 ?
   (Parer aux inconvénients des moteurs 0, où la rédaction des règles pose problème à cause des constantes :
    (Pour chaque circonstance qui apparaît, le codeur doit rédiger une règle dédiée. §/motor0/papa/papa_jardin-champ.png)
    (Tout cela induit beaucoup de cas à traiter : trop de règles dédiées à écrire. On croule sous la combinatoire : 12*13*13=2028. §/motor0/NregCumCst.png) ) ) 
  (Principe du moteur d'inférence d'ordre 1, c'est à dire basé sur l'utilisation de variables : §/variable/varVal.png
   (Avec le moteur 1 utiliser les variables facilite la programmation. Ex : coder le changement de lieu.
    (Notion de variable : _x *x ou encore celle du langage naturel. §/variable/qqSomAlg.png)
    (Ces variables, ces teneurs, conteneurs, fonctionnent comme des outils universels : la main, la pince, le dossier, le registre : §/teneur/a.JPG)
    (L'utilisation des variables dans les règles des SE correspond à l'emploi des pronoms dans le langage naturel. §/contxt/txt.png)
    (Dans un tel moteur, la généralisation apportée par l'utilisation de variables facilite la rédaction des règles. §/motor1/exA3var/hintA3var.png)
    (Elles sont plus générales : À l'aide des déïctiques ⊈ici et maintenant⊉, il suffit de décrire la situation présente et elle s'applique à N situations. §/agent/07Tropic/forager/a.png) ) 
   (Règle de production à une variable :
    (Présentation de la règle de base : elle modélise le déplacement d'une personne du pré au champ. §/motor1/exA1var/1regBrut.png)
    (En dehors de la règle de base, le programmeur rajoute un commentaire ⊈en vert⊉, où intervient la variable : §/motor1/exA1var/2regHint.png)
    (Pour appliquer une règle, on teste, prospecte toutes les parties de l'état du monde. Voici, en couleur ardoise, celle qui va coïncider avec la tête de règle : §/motor1/exA1var/3avant.png)
    (Ce bout de l'état du monde, cet ''état avant'' coÏncide avec la tête de règle au prix de l'unification : quelqu'un → Jim. §/motor1/exA1var/4unifie.png)
    (En propageant cet instanciation, càd cet environnement dans la queue de règle on obtient le nouvel état du monde : §/motor1/exA1var/5propQueu.png)
    (En propageant cet instanciation dans le commentaire on obtient une explication instanciée de l'action effectuée : §/motor1/exA1var/6propHint.png) ) 
   (Règle de production à 3 variables : qq qui est qqpart et ne porte rien, y prend qqchose. §/motor1/exA3var/1regBrut.png
    (Présentation de la règle de base : elle modélise quelqu'un qui a mes mains vides et prend un objet qui est sur place. §/motor1/exA3var/1regBrut.png)
    (En dehors de la règle de base, le programmeur rajoute un commentaire ⊈en vert⊉, où intervient la variable : §/motor1/exA3var/2regHint.png)
    (On teste toutes les parties de l'état du monde. Voici, en couleur bleue, celle qui va coïncider avec la tête de règle : §/motor1/exA3var/3avant.png)
    (Ce bout de l'état du monde, cet ''état avant'' coÏncide avec la tête de règle au prix de 3 unifications : qq→maman qqpart→maison qqchose→panier. §/motor1/exA3var/4unifie.png)
    (En propageant cet instanciation, càd cet environnement dans la queue de règle on obtient le nouvel état du monde : §/motor1/exA3var/5propQueu.png)
    (En propageant cet instanciation dans le commentaire on obtient une explication instanciée de l'action effectuée : §/motor1/exA3var/6propHint.png) ) ) 
  (∫k1 permet l'utilisation des variables pour la programmation des SE :
   (Pour décrire plus facilement les situations, rédiger des règles munies de variables ⊈grammaire contextuelle⊉
    (Décrire les changements du monde §/netSemantiq/as1Reg.png)
    (Les actions des agents changent l'état du monde en changeant ses objets, entités et en modifiant leurs propriétés, inter-relations, inter-fonctions. §/mond-EtaDu/ptiCol/3Rsous.png) ) ) ) 
 (Ici, préciser le synoptique des systèmes experts
  (La base de faits : elle décrit l'état de départ du système, càd avant l'action :
   (Ça peut aussi être l'état du monde avant la séquence d'actions. §/mond-EtaDu/ptiCol/3Rsur.png
    (sous⊈Chaise, Table⊉ : sur⊈Boîte, Table⊉ : àCôté⊈Table, mur⊉.) ) 
   (Ça peut encore être la formule de départ :
    (⊈va '⊈⊈2⊉+⊈3⊉⊉⊉ : je lui demande de traiter ⊈2⊉+⊈3⊉) ) ) 
  (La base de règles
   (Elle équivaut à un programme
    (Elle décrit les actions que les agents peuvent effectuer sur les états du monde. Voici qq exemples :
     (Les règles de la grammaire du langage C ⊈afin de vérifier la syntaxe d'un langage⊉. §/grammar/syntaxeD1insJFL_C.png)
     (Quelques règles, basiques de l'addition selon Péano, transcrites en Lisp : §/regProd/2+3=5.png) ) ) 
   (Chaque règle est constituée d'une tête ⊈à gauche⊉ et d'une queue ⊈à droite⊉. §/regl/tet-que.png
    (La tête décrit la situation à traiter, càd l'état du monde concerné ⊈avant l'action⊉, ou encore la propriété à vérifier, )
    (La queue décrit l'action à effectuer, ou bien l'état d'arrivée final, càd après qu'elle ait eut lieu. §/regl/formeGene.png
     (Ex 1 : après l'action, l'état d'arrivé est : Papa est dans le pré. §/motor0/jar-pre/reg.png)
     (Ex 2 : "ins ::= ins_sélection" : pour démontrer qu'on est en présence d'une instruction, il faut essayer de voir si c'est une instruction de sélection. )
     (Ex 3 : si "obstacle_devant" alors exécute : tourneGauche⊈90°⊉;)
     (Ex 4 : 3 → ⊈1 1 1⊉ : le chiffre 3 se réécrit en une chaîne de trois éléments : ⊈1 1 1⊉. ⊈conversion en base unaire⊉.) ) ) 
   (Notion de partition de l'espace d'états : c'est un portrait à touches pointillistes de toutes les situations qui peuvent se présenter.
    (La base de règles définit le comportement de l'agent : elle lui dit ce qu'il doit faire dans chaque situation possible ⊈pour chaque état de l'espace⊉.
     (1⊉ Repérage de chaque état :
      (Chaque état ⊈chaque situation possible⊉ doit être repéré afin d'être programmé. Ex de partition de l'espace d'états. §/parti°/Puzzle.png)
      (Donc le peintre doit couvrir entièrement le canevas, car, en programmation le moindre trou génère un bug. §/tessela°/dirichletVoronoil.png) ) 
     (2⊉ Programmation de chaque état : dire à l'agent ce qu'il doit faire dans chaque situation possible. §/parti°/biject°.png
      (C'est une démarche déïctique : on programme pour "ici et maintenant" §/txt/hicEtNunc.png)
      (Ce positionnement égocentré, où chacun voit midi à sa porte, facilite le travail de programmation. §/contxt/programEachStat.png) ) 
     (Note : un programme doit envisager tous les cas possibles, sinon le code est bogué. Mais avec les variables ça devient difficile. §/parti°/biject°2.png) ) ) ) 
  (Le moteur d'inférence
   (C'est un moteur : c'est une mécanique, très technique, écrite en lisp, C, c++ ou en Java ⊈au moyen des pointeurs⊉.)
   (Il est chargé d'appliquer les règles aux faits :
    (Vu l'état du monde, pas à pas, il explore la base de règles, depuis le début et essaie d'en appliquer une au moyen du processus d'unification.)
    (Si c'est le cas, il transforme l'état du monde selon les spécifications de la queue de la règle utilisée, et c'est reparti pour un tour.) ) 
   (Il effectue un traitement causal et contingent
    (Contingent : qui subit les effets de son environnement : qui est déterminé ou traité en fonction de son voisinage, entourage.)
    (Causal : empreint de liens de causalité : toute cause a son effet, tout effet a sa cause. ) ) 
   (Démarche causale de simulation
    (Ainsi, pour un moteur fonctionnant en simulation, on obtient le nouvel état du monde, transformé par les actions des agents. §/simula°/grid/n.png) ) ) 
  (Par-dessus le SE, la couche Interface Homme Machine ⊈IHM⊉
   (Aspect rudimentaire des premiers SE
    (Pour utiliser les premiers SE, il fallait soulever le capot et mettre les mains dans le cambouis, i.e. travailler au niveau du langage de base ⊈historiquement : d'abord Lisp, puis Prolog et C++⊉. )
    (Ensuite, les développeurs ont ajouté des logiciels pour interfacer la machine vers l'homme. §/systExpert/vueGlobal.png) ) 
   (Pour l'ergonomie, le but est de tendre vers la convivialité de l'échange oral
    (La coquille du SE est une interface pour permettre à l'homme non spécialiste, de faire travailler la machine, de rentrer les données et les règles. )
    (Le but est qu'elle soit la plus conviviale possible. Car c'est la machine qui doit s’adapter à l’homme, et non l’inverse. )
    (Évidemment une interface en langage naturel serait merveilleuse, mais... !) ) 
   (Le cogniticien est chargé de maintenir la cohérence des données et des traitements décrits, effectués.
    (Il faut signaler le travail difficile du cogniticien qui doit rédiger l’expertise, i.e. les règles. )
    (Ceci implique un travail de relations humaines pour interviewer l'expert et faire le diagnostic de son expertise. )
    (La chose peut parfois être difficile, quand le savoir de l'homme du terrain est tellement instinctif, qu'il éprouve des difficultés à le formuler.) ) 
   (L'expert, spécialiste du domaine à expertiser
    (En général, il n'est pas informaticien, donc le pb est que sa pensée ne s'effectue pas forcément en termes de logique mathématique. )
    (De plus il arrive, que comme chacun de nous, il soit détenteur de connaissances, d'expertises, mais applique les règles correspondantes de manière intuitive, inconsciente. Dans ce cas, il éprouve des difficultés à les formuler clairement afin que le cogniticien puisse les restituer.) ) ) ) 
 (Positionnement du système expert : il permet de développer rapidement une maquette, un produit ⊈pour un marché qui évolue vite⊉
  (Sur le marché informatique la durée de vie des programmes est de plus en plus courte.
   (Donc il est important que le développement d'un programme soit de plus en plus rapide. )
   (Vite fait : allons à l'essentiel : plus le temps de s'attacher aux apparences. C'est ainsi que j'ai développés n démos au moyen de mon moteur 1.)
   (L'important c'est d'annoncer rapidement un produit, même s'il va tarder à paraître, pour gêner la concurence !
    (Citer l'exemple de Pierre Etchegaray qui à dit : '' J'ai rapidement développé une maquette en Prolog, pour faire baver le client ''.) ) ) 
  (La durée de vie des 3 composants d'un S.E. est différente. §/systExpert/coeur.png
   (Le moteur d'inférence, rédigé un bonne fois pour toutes, doit être versatile, adaptable, afin de pouvoir servir longtemps.
    (Dans ce sens, il est réutilisable pour/dans beaucoup de situations presque semblables.
     (Tant qu'on lui demande de travailler sur des règles et des faits.) ) ) 
   (La base de règles correspondant à un domaine
    (Tant qu'on reste dans le même domaine, on peut réutiiser la BR.) ) 
   (La base de faits
    (Évidemment, elle est dédiée à chaque situation traitée.) ) ) ) 
 (La grande critique faite aux SE, le manque d'épaisseur ontologique. la réponse de Lenat : les îlots de savoir. §/ilotDeSavoir/c.png)
 (Conclure : les SE étaient à la mode dans les années 80. Maintenant ils n'ont pas disparu mais on parle surtout des réseaux de neurones.) ) 